Subject: bug#17330: files.el cd-absolute overcome false negative from file-executable-p

From: Eli Zaretskii <[email-masked]>
Date: Sun, 11 May 2014 21:43:32 +0300

> Date: Sun, 11 May 2014 20:26:10 +0200
> From: Philip Hodges <[email-masked]>
> CC: [email-masked], [email-masked]
> 
> >> I'm having a hard time understanding why you want to put so much faith
> >> in functions that are not reliable now, and will be quite hard or even
> >> genuinely impossible to make reliable in all of quite a large number of
> >> more or less realistic test scenarios.
> >
> > The functions are reliable.  It's just that you have some obscure
> > situation with the share owner, file/directory owner, and network
> > connection, and this combination bites you.  It might also be a Cygwin
> > issue.
> 
> They are subject to race conditions, false positives and false 
> negatives. They are reliable only in the sense that they generally do 
> return (unless the network hangs, is there any way to stay responsive 
> when that happens?) and the answer is quite often a true positive or 
> true negative.

I disagree with this, obviously.  Perfectly logical and systematic
behavior can appear random and "unreliable" to an observer who does
not understand that internal logic.

> I just skimmed through yet another tiring article about how there are 
> fundamental reasons why cygwin can't always get permissions and ACLs 
> exactly right, even without specifically mentioning remote SMB servers. 

Those articles are mostly trash, written by people who didn't bother
to learn the subject, and instead spread FUD.

> I'm quite convinced the cygwin folks would have already done it if it 
> was actually possible.

Maybe they don't know about this.  Which is why I think telling them
about the problem should be a good idea.  They do fix new problems
they encounter; e.g., they've just learned about a problem with
Microsoft Accounts, and mostly fixed it.

> If it was affecting Samba (recent with SMB2?) on GNU/Linux or
> Apple's own new SMB in MacOSX 10.9 (which defaults to SMB2.x)
> instead of just Oracle's Solaris (likely still SMB1) then would you
> still write it off as obscure?

Yes.  Again, it could also be a Cygwin issue, perhaps due to something
that rarely happens or something new.